#include <raylib.h>

#include "Panda.hpp"

static panda::Scene* currentScene = nullptr;

// CORE
void panda::CreateWindow(int w, int h, const char *str)
{
	Random::getInstance().setSeedFromTime();

	SetConfigFlags(
		FLAG_MSAA_4X_HINT | FLAG_WINDOW_RESIZABLE);

	#if PLATFORM_ANDROID
		InitWindow(0, 0, str);
	#elif PLATFORM_DESKTOP
		InitWindow(w, h, str);
		SetWindowMinSize(w*0.8f, h*0.8f);
	#endif

	SetExitKey(-1);
}

void panda::AppUpdate()
{
	if (currentScene != nullptr)
		currentScene->update();
}

void panda::SetScene(Scene* scene)
{
	if (currentScene != nullptr)
	{
		delete currentScene;
		currentScene = nullptr;
	}

	currentScene = scene;
}

panda::Scene* panda::GetScene()
{
	return currentScene;
}

// UTILS
panda::Random &panda::GetDefaultRandom()
{
	return Random::getInstance();
}