#pragma once
#include <cstdint>

namespace panda
{
	class Random {
		public:
			static Random& getInstance()
			{
				static Random instance;
				return instance;
			}
			
			Random(uint32_t _w = 521288629, uint32_t _z = 362436069);
			void setSeed(uint32_t w);
			void setSeed(uint32_t w, uint32_t z);
			void setSeedFromTime();

			uint32_t MWC();
			float UNI();
			float range(float min, float max);
			float rangeEx(float min, float max, float lamda);

			float xorshift_uni(uint32_t x);
			float xorshift64_uni(uint64_t x);
			uint32_t xorshift(uint32_t x);
			uint64_t xorshift64(uint64_t x);

		private:
			uint32_t m_w;
			uint32_t m_z;
			float inv_uni = 2.3283064e-10;
			float inv_uni64 = 5.4210109e-20;
	};
}